Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4441)
@@ -2310,13 +2312,13 @@
 !--                Spectral albedos especially for building green surfaces
                    IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(ind_pav_green,m) =                      &
+                      surf_usm_h%aldir(m,ind_pav_green) =                      &
                                                 albedo_pars_f%pars_xy(3,j,i)
-                      surf_usm_h%aldif(ind_pav_green,m) =                      &
+                      surf_usm_h%aldif(m,ind_pav_green) =                      &
                                                 albedo_pars_f%pars_xy(3,j,i)
                    ENDIF
                    IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(ind_pav_green,m) =                      &
+                      surf_usm_h%asdir(m,ind_pav_green) =                      &
                                                 albedo_pars_f%pars_xy(4,j,i)
-                      surf_usm_h%asdif(ind_pav_green,m) =                      &
+                      surf_usm_h%asdif(m,ind_pav_green) =                      &
                                                 albedo_pars_f%pars_xy(4,j,i)
                    ENDIF
@@ -2324,13 +2326,13 @@
 !--                Spectral albedos especially for building window surfaces
                    IF ( albedo_pars_f%pars_xy(5,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(ind_wat_win,m) =                        &
+                      surf_usm_h%aldir(m,ind_wat_win) =                        &
                                                 albedo_pars_f%pars_xy(5,j,i)
-                      surf_usm_h%aldif(ind_wat_win,m) =                        &
+                      surf_usm_h%aldif(m,ind_wat_win) =                        &
                                                 albedo_pars_f%pars_xy(5,j,i)
                    ENDIF
                    IF ( albedo_pars_f%pars_xy(6,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(ind_wat_win,m) =                        &
+                      surf_usm_h%asdir(m,ind_wat_win) =                        &
                                                 albedo_pars_f%pars_xy(6,j,i)
-                      surf_usm_h%asdif(ind_wat_win,m) =                        &
+                      surf_usm_h%asdif(m,ind_wat_win) =                        &
                                                 albedo_pars_f%pars_xy(6,j,i)
                    ENDIF
@@ -2352,21 +2354,21 @@
                       IF ( albedo_pars_f%pars_xy(0,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )                                &
-                         surf_lsm_v(l)%albedo(ind_type,m) =                    &
+                         surf_lsm_v(l)%albedo(m,ind_type) =                    &
                                        albedo_pars_f%pars_xy(0,j+joff,i+ioff)
                       IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )                                &
-                         surf_lsm_v(l)%aldir(ind_type,m) =                     &
+                         surf_lsm_v(l)%aldir(m,ind_type) =                     &
                                        albedo_pars_f%pars_xy(1,j+joff,i+ioff)
                       IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )                                &
-                         surf_lsm_v(l)%aldif(ind_type,m) =                     &
+                         surf_lsm_v(l)%aldif(m,ind_type) =                     &
                                        albedo_pars_f%pars_xy(1,j+joff,i+ioff)
                       IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )                                &
-                         surf_lsm_v(l)%asdir(ind_type,m) =                     &
+                         surf_lsm_v(l)%asdir(m,ind_type) =                     &
                                        albedo_pars_f%pars_xy(2,j+joff,i+ioff)
                       IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )                                &
-                         surf_lsm_v(l)%asdif(ind_type,m) =                     &
+                         surf_lsm_v(l)%asdif(m,ind_type) =                     &
                                        albedo_pars_f%pars_xy(2,j+joff,i+ioff)
                    ENDDO
@@ -2387,5 +2389,5 @@
                          IF ( albedo_pars_f%pars_xy(0,j+joff,i+ioff) /=        &
                               albedo_pars_f%fill )                             &
-                            surf_usm_v(l)%albedo(ind_type,m) =                 &
+                            surf_usm_v(l)%albedo(m,ind_type) =                 &
                                           albedo_pars_f%pars_xy(0,j+joff,i+ioff)
                       ENDDO
@@ -2394,14 +2396,14 @@
                       IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%aldir(ind_veg_wall,m) =                 &
+                         surf_usm_v(l)%aldir(m,ind_veg_wall) =                 &
                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
-                         surf_usm_v(l)%aldif(ind_veg_wall,m) =                 &
+                         surf_usm_v(l)%aldif(m,ind_veg_wall) =                 &
                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
                       ENDIF
                       IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%asdir(ind_veg_wall,m) =                 &
+                         surf_usm_v(l)%asdir(m,ind_veg_wall) =                 &
                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
-                         surf_usm_v(l)%asdif(ind_veg_wall,m) =                 &
+                         surf_usm_v(l)%asdif(m,ind_veg_wall) =                 &
                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
                       ENDIF
@@ -2410,14 +2412,14 @@
                       IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%aldir(ind_pav_green,m) =                &
+                         surf_usm_v(l)%aldir(m,ind_pav_green) =                &
                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
-                         surf_usm_v(l)%aldif(ind_pav_green,m) =                &
+                         surf_usm_v(l)%aldif(m,ind_pav_green) =                &
                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
                       ENDIF
                       IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%asdir(ind_pav_green,m) =                &
+                         surf_usm_v(l)%asdir(m,ind_pav_green) =                &
                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
-                         surf_usm_v(l)%asdif(ind_pav_green,m) =                &
+                         surf_usm_v(l)%asdif(m,ind_pav_green) =                &
                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
                       ENDIF
@@ -2426,14 +2428,14 @@
                       IF ( albedo_pars_f%pars_xy(5,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%aldir(ind_wat_win,m) =                  &
+                         surf_usm_v(l)%aldir(m,ind_wat_win) =                  &
                                          albedo_pars_f%pars_xy(5,j+joff,i+ioff)
-                         surf_usm_v(l)%aldif(ind_wat_win,m) =                  &
+                         surf_usm_v(l)%aldif(m,ind_wat_win) =                  &
                                          albedo_pars_f%pars_xy(5,j+joff,i+ioff)
                       ENDIF
                       IF ( albedo_pars_f%pars_xy(6,j+joff,i+ioff) /=           &
                            albedo_pars_f%fill )  THEN
-                         surf_usm_v(l)%asdir(ind_wat_win,m) =                  &
+                         surf_usm_v(l)%asdir(m,ind_wat_win) =                  &
                                          albedo_pars_f%pars_xy(6,j+joff,i+ioff)
-                         surf_usm_v(l)%asdif(ind_wat_win,m) =                  &
+                         surf_usm_v(l)%asdif(m,ind_wat_win) =                  &
                                          albedo_pars_f%pars_xy(6,j+joff,i+ioff)
                       ENDIF
@@ -2461,75 +2463,75 @@
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_veg_wall,m) =                         &
+                         surf_usm_h%albedo(m,ind_veg_wall) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_b_wall,is)
-                         surf_usm_h%albedo_type(ind_veg_wall,m) = 0
+                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_l_wall,is) /=      &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(ind_veg_wall,m) =                          &
+                         surf_usm_h%aldir(m,ind_veg_wall) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                         surf_usm_h%aldif(ind_veg_wall,m) =                          &
+                         surf_usm_h%aldif(m,ind_veg_wall) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                         surf_usm_h%albedo_type(ind_veg_wall,m) = 0
+                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_s_wall,is) /=      &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(ind_veg_wall,m) =                          &
+                         surf_usm_h%asdir(m,ind_veg_wall) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                         surf_usm_h%asdif(ind_veg_wall,m) =                          &
+                         surf_usm_h%asdif(m,ind_veg_wall) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                         surf_usm_h%albedo_type(ind_veg_wall,m) = 0
+                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_wat_win,m) =                          &
+                         surf_usm_h%albedo(m,ind_wat_win) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_b_win,is)
-                         surf_usm_h%albedo_type(ind_wat_win,m) = 0
+                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_l_win,is) /=       &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(ind_wat_win,m) =                           &
+                         surf_usm_h%aldir(m,ind_wat_win) =                           &
                                   building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                         surf_usm_h%aldif(ind_wat_win,m) =                           &
+                         surf_usm_h%aldif(m,ind_wat_win) =                           &
                                   building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                         surf_usm_h%albedo_type(ind_wat_win,m) = 0
+                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_s_win,is) /=       &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(ind_wat_win,m) =                           &
+                         surf_usm_h%asdir(m,ind_wat_win) =                           &
                                   building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                         surf_usm_h%asdif(ind_wat_win,m) =                           &
+                         surf_usm_h%asdif(m,ind_wat_win) =                           &
                                   building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                         surf_usm_h%albedo_type(ind_wat_win,m) = 0
+                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_pav_green,m) =                        &
+                         surf_usm_h%albedo(m,ind_pav_green) =                        &
                                   building_surface_pars_f%pars(ind_s_alb_b_green,is)
-                         surf_usm_h%albedo_type(ind_pav_green,m) = 0
+                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_l_green,is) /=     &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%aldir(ind_pav_green,m) =                         &
+                         surf_usm_h%aldir(m,ind_pav_green) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                         surf_usm_h%aldif(ind_pav_green,m) =                         &
+                         surf_usm_h%aldif(m,ind_pav_green) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                         surf_usm_h%albedo_type(ind_pav_green,m) = 0
+                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_s_green,is) /=     &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%asdir(ind_pav_green,m) =                         &
+                         surf_usm_h%asdir(m,ind_pav_green) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                         surf_usm_h%asdif(ind_pav_green,m) =                         &
+                         surf_usm_h%asdif(m,ind_pav_green) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                         surf_usm_h%albedo_type(ind_pav_green,m) = 0
+                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
                       ENDIF
 
@@ -2554,75 +2556,75 @@
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_veg_wall,m) =                      &
+                            surf_usm_v(l)%albedo(m,ind_veg_wall) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_b_wall,is)
-                            surf_usm_v(l)%albedo_type(ind_veg_wall,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_veg_wall) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_l_wall,is) /=      &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%aldir(ind_veg_wall,m) =                       &
+                            surf_usm_v(l)%aldir(m,ind_veg_wall) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                            surf_usm_v(l)%aldif(ind_veg_wall,m) =                       &
+                            surf_usm_v(l)%aldif(m,ind_veg_wall) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_l_wall,is)
-                            surf_usm_v(l)%albedo_type(ind_veg_wall,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_veg_wall) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_s_wall,is) /=      &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%asdir(ind_veg_wall,m) =                       &
+                            surf_usm_v(l)%asdir(m,ind_veg_wall) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                            surf_usm_v(l)%asdif(ind_veg_wall,m) =                       &
+                            surf_usm_v(l)%asdif(m,ind_veg_wall) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_s_wall,is)
-                            surf_usm_v(l)%albedo_type(ind_veg_wall,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_veg_wall) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_wat_win,m) =                       &
+                            surf_usm_v(l)%albedo(m,ind_wat_win) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_b_win,is)
-                            surf_usm_v(l)%albedo_type(ind_wat_win,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_wat_win) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_l_win,is) /=       &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%aldir(ind_wat_win,m) =                        &
+                            surf_usm_v(l)%aldir(m,ind_wat_win) =                        &
                                      building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                            surf_usm_v(l)%aldif(ind_wat_win,m) =                        &
+                            surf_usm_v(l)%aldif(m,ind_wat_win) =                        &
                                      building_surface_pars_f%pars(ind_s_alb_l_win,is)
-                            surf_usm_v(l)%albedo_type(ind_wat_win,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_wat_win) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_s_win,is) /=       &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%asdir(ind_wat_win,m) =                        &
+                            surf_usm_v(l)%asdir(m,ind_wat_win) =                        &
                                      building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                            surf_usm_v(l)%asdif(ind_wat_win,m) =                        &
+                            surf_usm_v(l)%asdif(m,ind_wat_win) =                        &
                                      building_surface_pars_f%pars(ind_s_alb_s_win,is)
-                            surf_usm_v(l)%albedo_type(ind_wat_win,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_wat_win) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_pav_green,m) =                     &
+                            surf_usm_v(l)%albedo(m,ind_pav_green) =                     &
                                      building_surface_pars_f%pars(ind_s_alb_b_green,is)
-                            surf_usm_v(l)%albedo_type(ind_pav_green,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_pav_green) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_l_green,is) /=     &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%aldir(ind_pav_green,m) =                      &
+                            surf_usm_v(l)%aldir(m,ind_pav_green) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                            surf_usm_v(l)%aldif(ind_pav_green,m) =                      &
+                            surf_usm_v(l)%aldif(m,ind_pav_green) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_l_green,is)
-                            surf_usm_v(l)%albedo_type(ind_pav_green,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_pav_green) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_s_green,is) /=     &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%asdir(ind_pav_green,m) =                      &
+                            surf_usm_v(l)%asdir(m,ind_pav_green) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                            surf_usm_v(l)%asdif(ind_pav_green,m) =                      &
+                            surf_usm_v(l)%asdif(m,ind_pav_green) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_s_green,is)
-                            surf_usm_v(l)%albedo_type(ind_pav_green,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_pav_green) = 0
                          ENDIF
 
@@ -3272,18 +3274,18 @@
                    DO  m = 1, surf%ns
                       k = surf%k(m)
-                      surf%rad_sw_out(m) = ( surf%frac(ind_veg_wall,m)  *      &
-                                             surf%albedo(ind_veg_wall,m)       &
-                                           + surf%frac(ind_pav_green,m) *      &
-                                             surf%albedo(ind_pav_green,m)      &
-                                           + surf%frac(ind_wat_win,m)   *      &
-                                             surf%albedo(ind_wat_win,m) )      &
+                      surf%rad_sw_out(m) = ( surf%frac(m,ind_veg_wall)  *      &
+                                             surf%albedo(m,ind_veg_wall)       &
+                                           + surf%frac(m,ind_pav_green) *      &
+                                             surf%albedo(m,ind_pav_green)      &
+                                           + surf%frac(m,ind_wat_win)   *      &
+                                             surf%albedo(m,ind_wat_win) )      &
                                            * surf%rad_sw_in(m)
                    
-                      surf%rad_lw_out(m) = ( surf%frac(ind_veg_wall,m)  *      &
-                                             surf%emissivity(ind_veg_wall,m)   &
-                                           + surf%frac(ind_pav_green,m) *      &
-                                             surf%emissivity(ind_pav_green,m)  &
-                                           + surf%frac(ind_wat_win,m)   *      &
-                                             surf%emissivity(ind_wat_win,m)    &
+                      surf%rad_lw_out(m) = ( surf%frac(m,ind_veg_wall)  *      &
+                                             surf%emissivity(m,ind_veg_wall)   &
+                                           + surf%frac(m,ind_pav_green) *      &
+                                             surf%emissivity(m,ind_pav_green)  &
+                                           + surf%frac(m,ind_wat_win)   *      &
+                                             surf%emissivity(m,ind_wat_win)    &
                                            )                                   &
                                            * sigma_sb                          &
@@ -3291,10 +3293,10 @@
                    
                       surf%rad_lw_out_change_0(m) =                            &
-                                         ( surf%frac(ind_veg_wall,m)  *        &
-                                           surf%emissivity(ind_veg_wall,m)     &
-                                         + surf%frac(ind_pav_green,m) *        &
-                                           surf%emissivity(ind_pav_green,m)    &
-                                         + surf%frac(ind_wat_win,m)   *        &
-                                           surf%emissivity(ind_wat_win,m)      &
+                                         ( surf%frac(m,ind_veg_wall)  *        &
+                                           surf%emissivity(m,ind_veg_wall)     &
+                                         + surf%frac(m,ind_pav_green) *        &
+                                           surf%emissivity(im,ind_pav_green)    &
+                                         + surf%frac(m,ind_wat_win)   *        &
+                                           surf%emissivity(m,ind_wat_win)      &
                                          ) * 4.0_wp * sigma_sb                 &
                                          * ( surf%pt_surface(m) * exner(k) )**3
@@ -3340,18 +3342,18 @@
 !
 !--                Weighted average according to surface fraction. 
-                   surf%rad_sw_out(m) = ( surf%frac(ind_veg_wall,m)  *         &
-                                          surf%albedo(ind_veg_wall,m)          &
-                                        + surf%frac(ind_pav_green,m) *         &
-                                          surf%albedo(ind_pav_green,m)         &
-                                        + surf%frac(ind_wat_win,m)   *         &
-                                          surf%albedo(ind_wat_win,m) )         &
+                   surf%rad_sw_out(m) = ( surf%frac(m,ind_veg_wall)  *         &
+                                          surf%albedo(m,ind_veg_wall)          &
+                                        + surf%frac(m,ind_pav_green) *         &
+                                          surf%albedo(m,ind_pav_green)         &
+                                        + surf%frac(m,ind_wat_win)   *         &
+                                          surf%albedo(m,ind_wat_win) )         &
                                         * surf%rad_sw_in(m)
 
-                   surf%rad_lw_out(m) = ( surf%frac(ind_veg_wall,m)  *         &
-                                          surf%emissivity(ind_veg_wall,m)      &
-                                        + surf%frac(ind_pav_green,m) *         &
-                                          surf%emissivity(ind_pav_green,m)     &
-                                        + surf%frac(ind_wat_win,m)   *         &
-                                          surf%emissivity(ind_wat_win,m)       &
+                   surf%rad_lw_out(m) = ( surf%frac(m,ind_veg_wall)  *         &
+                                          surf%emissivity(m,ind_veg_wall)      &
+                                        + surf%frac(m,ind_pav_green) *         &
+                                          surf%emissivity(m,ind_pav_green)     &
+                                        + surf%frac(m,ind_wat_win)   *         &
+                                          surf%emissivity(m,ind_wat_win)       &
                                         )                                      &
                                         * sigma_sb                             &
@@ -3359,10 +3361,10 @@
 
                    surf%rad_lw_out_change_0(m) =                               &
-                                      ( surf%frac(ind_veg_wall,m)  *           &
-                                        surf%emissivity(ind_veg_wall,m)        &
-                                      + surf%frac(ind_pav_green,m) *           &
-                                        surf%emissivity(ind_pav_green,m)       &
-                                      + surf%frac(ind_wat_win,m)   *           &
-                                        surf%emissivity(ind_wat_win,m)         &
+                                      ( surf%frac(m,ind_veg_wall)  *           &
+                                        surf%emissivity(m,ind_veg_wall)        &
+                                      + surf%frac(m,ind_pav_green) *           &
+                                        surf%emissivity(m,ind_pav_green)       &
+                                      + surf%frac(m,ind_wat_win)   *           &
+                                        surf%emissivity(m,ind_wat_win)         &
                                       ) * 4.0_wp * sigma_sb                    &
                                       * ( surf%pt_surface(m) * exner(k) )**3
